<template>
  <div>
    <b-field label="Type" horizontal>
      <div>
        <b-radio v-model="type" name="type" native-value="offer">Offer</b-radio>
        <b-radio v-model="type" name="type" native-value="contract">Contract</b-radio>
      </div>
    </b-field>
    <b-field label="Recipient" horizontal>
      <b-input v-model="recipient" required placeholder="Recipient agent ID" />
    </b-field>
    <b-field label="Sender" horizontal>
      <b-input v-model="sender" required placeholder="Sender agent ID" />
    </b-field>
    <b-field label="Version" horizontal>
      <b-input v-model="version" required placeholder="Version" />
    </b-field>
    <b-field label="Method" horizontal>
      <b-select v-model="method" placeholder="HTTP Method" expanded>
          <option
              v-for="method in methods"
              :value="method"
              :key="method">
              {{ method }}
          </option>
      </b-select>
    </b-field>
    <b-field label="Path" horizontal>
      <b-input v-model="path" required placeholder="Path" />
    </b-field>
    <PolicyTable :policies="result" :actions="false" :decision="true" />
    <div class="content pt-5">
      <blockquote>
        <em><strong>Note:</strong> the policy checker is meant to assist in defining the policies, the actual decisions are made during runtime in the Core Container. It is not guaranteed that the same decision is taken.</em>
      </blockquote>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator';
import PolicyTable from './PolicyTable.vue'

@Component({
  components: {
    PolicyTable
  }
})
export default class PolicyChecker extends Vue {
  methods = ['GET', 'POST', 'PUT', 'PATCH', 'DELETE', 'HEAD', 'OPTIONS']
  
  @Prop({required: true})
  contracts!: Array<any>

  @Prop({required: true})
  offers!: Array<any>

  type = 'offer'
  recipient = ''
  sender = ''
  method = 'GET'
  version = ''
  path = ''

  get result() {
    const policies = (this.type === 'offer') ? this.offers : this.contracts;

    return policies.map(policy => {
      if (((policy['ids:consumer']?.['@id'] || this.sender) === this.sender) && (policy['ids:provider']?.['@id'] || this.recipient) === this.recipient) {
        var decision = 'NOT APPLICABLE'
        const rules: Array<any> = (policy['ids:permission'] || []).concat(policy['ids:prohibition'] || [])
        if (rules.some(rule => (!rule['ids:assignee'] || rule['ids:assignee'].length === 0 || rule['ids:assignee'].some((assignee: any) => assignee['@id'] === this.sender)) &&
            (!rule['ids:assigner'] || rule['ids:assigner'].length === 0 || rule['ids:assigner'].some((assigner: any) => assigner['@id'] === this.recipient)))){
              return {
                ...policy,
                'ids:permission': (policy['ids:permission'] || []).map((rule: any) => {
                  const applicability = this.testApplicability(rule, 'ALLOW')
                  if (applicability.applicable) {
                    decision = 'ALLOW'
                  }
                  return applicability.rule;
                }),
                'ids:prohibition': (policy['ids:prohibition'] || []).map((rule: any) => {
                  const applicability = this.testApplicability(rule, 'PROHIBITED')
                  if (applicability.applicable) {
                    decision = 'PROHIBITED'
                  }
                  return applicability.rule;
                }),
                decision: decision
              }
        } else {
          return false;
        }
      } else {
        return false;
      }
    }).filter(policy => policy)
  }

  testApplicability(rule: any, decision: string): any {
    if ((!rule['ids:assignee'] || rule['ids:assignee'].length === 0 || rule['ids:assignee'].some((assignee: any) => assignee['@id'] === this.sender)) &&
        (!rule['ids:assigner'] || rule['ids:assigner'].length === 0 || rule['ids:assigner'].some((assigner: any) => assigner['@id'] === this.recipient))) {
      if (rule['ids:target']['@id'].startsWith('urn:ids:regex:')) {
        const version = RegExp(rule['ids:target']['@id'].replace('urn:ids:regex:/','').split('/')[0])
        const path = RegExp(rule['ids:target']['@id'].replace('urn:ids:regex:/','').split('/').slice(1).join("/"))
        if (!rule['ids:action'].map((action: any) => action['@id']).includes(this.mapActionToMethod(this.method))) {
          return {
            rule: {
              ...rule,
              'decision': 'NOT APPLICABLE'
            },
            applicable: false
          }
        }
        if (version.test(this.version) && path.test(this.path)) {
          return {
            rule: {
              ...rule,
              'decision': decision
            },
            applicable: true
          }
        } else {
          return {
            rule: {
              ...rule,
              'decision': 'NOT APPLICABLE'
            },
            applicable: false
          }
        }
      } else {
        return {
          rule: {
            ...rule,
            'decision': 'UNDETERMINISTIC'
          },
          applicable: false
        }
      }
    } else {
      return {
        rule: {
          ...rule,
          'decision': 'NOT APPLICABLE'
        },
        applicable: false
      }
    }
  }

  mapActionToMethod(method: any): string {
    switch(method) {
      case 'GET':
        return 'https://w3id.org/idsa/code/READ'
      case 'POST':
        return 'https://w3id.org/idsa/code/WRITE'
      case 'PUT':
        return 'https://w3id.org/idsa/code/MODIFY'
      case 'PATCH':
        return 'https://w3id.org/idsa/code/MODIFY'
      case 'DELETE':
        return 'https://w3id.org/idsa/code/DELETE'
      case 'HEAD':
        return 'https://w3id.org/idsa/code/READ'
      case 'OPTIONS':
        return 'https://w3id.org/idsa/code/READ'
      default:
        return 'https://w3id.org/idsa/code/READ'
    }
  }
}


</script>